From 82763bb19307ab1c8f7dd1f4f2d6d412c6951993 Mon Sep 17 00:00:00 2001
From: cuijiajin <cuijiajin@uniontech.com>
Date: Thu, 11 Jun 2020 10:29:47 +0800
Subject: [PATCH v4 2/2] user32:Fix z order error when child window want to be
 topmost windows

        window with WS_CHILD does not need to change Z order
        when SetWindowPos param hwndInsertAfter is HWND_TOPMOST or HWND_NOTOPMOST

Signed-off-by: cuijiajin <cuijiajin@uniontech.com>
---
 dlls/user32/winpos.c | 12 +++++++++++-
 1 file changed, 11 insertions(+), 1 deletion(-)

diff --git a/dlls/user32/winpos.c b/dlls/user32/winpos.c
index b92a20df18..dc872ee961 100644
--- a/dlls/user32/winpos.c
+++ b/dlls/user32/winpos.c
@@ -1986,7 +1986,7 @@ static BOOL fixup_flags( WINDOWPOS *winpos, const RECT *old_window_rect, int par
     /* Check hwndInsertAfter */
     if (winpos->flags & SWP_NOZORDER) goto done;
 
-    if (winpos->hwndInsertAfter == HWND_TOP)
+     if (winpos->hwndInsertAfter == HWND_TOP)
     {
         if (GetWindow(winpos->hwnd, GW_HWNDFIRST) == winpos->hwnd)
             winpos->flags |= SWP_NOZORDER;
@@ -2000,11 +2000,21 @@ static BOOL fixup_flags( WINDOWPOS *winpos, const RECT *old_window_rect, int par
     {
         if ((wndPtr->dwExStyle & WS_EX_TOPMOST) && GetWindow(winpos->hwnd, GW_HWNDFIRST) == winpos->hwnd)
             winpos->flags |= SWP_NOZORDER;
+
+        if ((wndPtr->dwStyle & (WS_CHILD | WS_POPUP)) == WS_CHILD)
+        {
+            winpos->flags |= SWP_NOZORDER;
+        }
     }
     else if (winpos->hwndInsertAfter == HWND_NOTOPMOST)
     {
         if (!(wndPtr->dwExStyle & WS_EX_TOPMOST))
             winpos->flags |= SWP_NOZORDER;
+
+        if ((wndPtr->dwStyle & (WS_CHILD | WS_POPUP)) == WS_CHILD)
+        {
+            winpos->flags |= SWP_NOZORDER;
+        }
     }
     else
     {
-- 
2.20.1

